#include <unistd.h>
#include <string>
#include <stdio.h>
#include <stdlib.h>
#include <iostream>
#include <filesystem>
#include <cstring>
#include <fstream>
#include <unistd.h>
/* 
 * File structure:
 * /etc/cowtool/
 *      |- enabled
 *      |- disabled
 *      \- install_template.sh
 *
 *
 * /sources/cowtool/buildspace/
 *
 * lick will load a template via a text editor of choice.
 * milk will run a script from Disabled, and if autoupdate, copy it to Enabled
 * herd will list both Enabled and Disabled
 * graze will run all the scripts in Enabled
 * Butcher will run in uninstall version of the script and remove it from Enabled
*/

bool ask(std::string prompt) {
  std::cout << prompt << " (Y/n) ";
  std::string response;
  std::cin >> response;

  if (response == "y" || response == "yes") {
    return true;
  } else if (response == "n" || response == "no") {
    return false;
  } else {
    // default to yes
    return true;
  }
}



int main(int argc, char* argv[]) {

	if ( argc == 1 ) {
		std::cout << " Cowtool 0.0 :" << std::endl;
		std::cout << "     - cowtool lick < name > < editor >         : Create/edit a package script" << std::endl;
		std::cout << "     - cowtool milk < name >                    : Install package" << std::endl;
		std::cout << "     - cowtool herd                             : List package scripts" << std::endl;
		std::cout << "     - cowtool graze < name / empty for all >   : Update packages, if empty do only autoupdate" << std::endl;
		std::cout << "     - cowtool butcher < name >                 : Uninstalls a package"  << std::endl;
		return 0;
	}

	std::string firstArg = argv[1];

	if ( firstArg == "lick") {

		if (argc < 3) {
			std::cout << "Package name required!" << std::endl;
			return 1;
		}

		std::string name = argv[2];
		std::string editor;
		if (argc < 4) {
			editor = "vim";
		} else {
			editor = argv[3];
		}

		
		std::string input="";
		
		if (!std::filesystem::exists("/etc/cowtool/disabled/install_"+name+".sh")) {
			std::cout << "First time installation! Watching you! Type 'manure' to cancel, 'exit' to save!" << std::endl;
			chdir("/sources/cowtool/buildspace/");
			std::cout << "Entered buildspace - don't forget to clean up before exiting!" << std::endl;
			
			std::ofstream out;
			out.open("/etc/cowtool/disabled/install_"+name+".sh", std::ios::app);
			
			out << "cd /sources/cowtool/buildspace/" << std::endl;

			while (input!="manure" && input!="exit"){
				
				out << input << std::endl;
				system(input.c_str());
				if (input.substr(0,3)=="cd "){
					chdir((input.substr(3)).c_str());
				}
				
				std::cout<< "[cowtool] : ";

				std::getline(std::cin, input);
			}
			
			out.close();
		}
		if (input=="manure") {
			// Cancel!
			system(("rm /etc/cowtool/disabled/install_"+name+".sh").c_str());
			std::cout << "Cancelled `"+ name << "`!" << std::endl;
		} else {
			system((editor+" /etc/cowtool/disabled/install_"+name+".sh").c_str());
			std::cout << "Remember to `milk` to update `"+ name << "`!" << std::endl;
		}
			
	} else if (firstArg == "milk") {
	
		if (argc < 3) {
			std::cout << "Package name required!" << std::endl;
			return 1;
		}

		std::string name = argv[2];
		
		if (ask("Should this package be updated when `graze` is run?")) {
			system(("cp -v /etc/cowtool/disabled/install_" + name + ".sh /etc/cowtool/enabled/install_" + name + ".sh").c_str());
		}
		
		system(("bash /etc/cowtool/disabled/install_" + name + ".sh").c_str());

	} else if (firstArg == "herd") {

		std::cout << "List of package scripts:" << std::endl << std::endl;
		system("ls -1 /etc/cowtool/disabled/");

		std::cout << std::endl << "List of package scripts marked as autoupdate:" << std::endl << std::endl;
		system("ls -1 /etc/cowtool/enabled/");

	} else if (firstArg == "graze") {
	
		// Loads directory
		std::filesystem::path dir("/etc/cowtool/enabled"); 
		for (const auto& entry : std::filesystem::directory_iterator(dir)) {
			if (entry.is_regular_file()) {
		       		system(("bash /etc/cowtool/enabled/" + entry.path().filename().string()).c_str());
			}
		}

	} else if (firstArg == "butcher") {
	
		if (argc < 3) {
			std::cout << "Package name required!" << std::endl;
			return 1;
		}

		std::string name = argv[2];
		
		system(("rm -f /etc/cowtool/enabled/install_"+name+".sh").c_str());
		std::cout << "Program removed from autoupdate list -- remember to uninstall it!" << std::endl;

	} else {

		std::cout << "Unknown argument!" << std::endl;
		std::cout << "Run without arguments for help menu." << std::endl;
		return 1;
	}

	return 0;

}
